"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => vpvepi,
  getDefaultSvgoOptions: () => getDefaultSvgoOptions
});
module.exports = __toCommonJS(src_exports);
var import_promises = require("fs/promises");
var import_compiler_sfc = require("vue/compiler-sfc");
var import_svgo = require("svgo");

// src/svgo-plugin-replace-fill.ts
var plugin = {
  name: "svgo-plugin-element-plus",
  type: "perItem",
  fn: (ast) => {
    if (ast.name == "path") {
      ast.attributes.fill = "currentColor";
    }
  }
};
var svgo_plugin_replace_fill_default = plugin;

// src/index.ts
var getDefaultSvgoOptions = (path) => {
  return {
    path,
    multipass: true,
    plugins: [
      "preset-default",
      "removeDimensions",
      {
        name: "removeAttrs",
        params: {
          attrs: "class"
        }
      },
      svgo_plugin_replace_fill_default
    ]
  };
};
function vpvepi(options = {}) {
  const svgRegex = /\.svg(\?(raw|component|url))?$/;
  const { svgoConfig, defaultQuery = "component" } = options;
  return {
    name: "vite-plugin-vue-element-plus",
    enforce: "pre",
    async load(id) {
      if (!id.match(svgRegex)) {
        return;
      }
      const [path, query] = id.split("?", 2);
      const queryType = query || defaultQuery;
      if (queryType === "url") {
        return;
      }
      let svgFileContent = "";
      try {
        svgFileContent = await (0, import_promises.readFile)(path, "utf-8");
      } catch (e) {
        console.warn(`#vite-plugin-vue-element-plus-icon: [${path}] couldn't be read.`, e);
        return;
      }
      if (queryType !== "raw") {
        const result = (0, import_svgo.optimize)(
          svgFileContent,
          svgoConfig ? svgoConfig(path) : getDefaultSvgoOptions(path)
        );
        if (result.error) {
          console.warn(
            `#vite-plugin-vue-element-plus-icon: [${path}] couldn't be handled by svgo.`,
            result.error
          );
          return;
        }
        svgFileContent = result.data;
      }
      const { code } = (0, import_compiler_sfc.compileTemplate)({
        id: JSON.stringify(id),
        source: svgFileContent,
        filename: path,
        transformAssetUrls: false
      });
      return `${code} 
 export default { render }`;
    }
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getDefaultSvgoOptions
});
